/**
* SmartFoxServer 2X
* CustomLogin Example
*
* (c) 2009 - 2010 gotoAndPlay()
* www.smartfoxserver.com
*/
package
{
	import com.smartfoxserver.v2.SmartFox
	import com.smartfoxserver.v2.core.SFSEvent
	import com.smartfoxserver.v2.entities.*
	import com.smartfoxserver.v2.entities.data.*
	import com.smartfoxserver.v2.entities.match.*
	import com.smartfoxserver.v2.entities.variables.*
	import com.smartfoxserver.v2.entities.invitation.*
	import com.smartfoxserver.v2.requests.*
	import com.smartfoxserver.v2.requests.game.*
	import com.smartfoxserver.v2.logging.*
	
	import flash.display.*
	import flash.events.*
	import flash.system.Security
	
	public class CustomLogin extends Sprite
	{	
		private var sfs:SmartFox
		private var autoJoin:Boolean = false
		
		public function CustomLogin()
		{
		 	sfs = new SmartFox()
			sfs.debug = true
			
			sfs.addEventListener(SFSEvent.CONNECTION, onConnection)
			sfs.addEventListener(SFSEvent.CONNECTION_LOST, onConnectionLost)
			
			sfs.addEventListener(SFSEvent.CONFIG_LOAD_SUCCESS, onConfigLoadSuccess)
			sfs.addEventListener(SFSEvent.CONFIG_LOAD_FAILURE, onConfigLoadFailure)
			
			sfs.addEventListener(SFSEvent.LOGIN, onLogin)
			sfs.addEventListener(SFSEvent.LOGIN_ERROR, onLoginError)
			
			sfs.addEventListener(SFSEvent.ROOM_JOIN, onJoin)
			sfs.addEventListener(SFSEvent.ROOM_JOIN_ERROR, onJoinError)
			
			bt_connect.addEventListener(MouseEvent.CLICK, onBtConnectClick)
			
			dTrace("SmartFox API: "+ sfs.version)
			dTrace("Click CONNECT to start...")
			
		}	
		
		//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
		// Button Handlers
		//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
		private function onBtConnectClick(evt:Event):void
		{
			sfs.loadConfig()
		}

		
		//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
		// Event Handlers
		//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
		
		private function onConnection(evt:SFSEvent):void
		{
			ta_debug.text = ""
			if (evt.params.success)
			{
				dTrace("Connection Success!")
				sfs.send(new LoginRequest(ti_name.text, ti_pass.text))
			}
			else
			{
				dTrace("Connection Failure: " + evt.params.errorMessage)
			}
		}
		
		private function onConnectionLost(evt:SFSEvent):void
		{
			dTrace("Connection was lost. Reason: " + evt.params.reason)
		}

		private function onLogin(evt:SFSEvent):void
		{
			dTrace("Logged in as: " + evt.params.user.name)
		}
		
		private function onLoginError(evt:SFSEvent):void
		{
			dTrace("Login Failure: " + evt.params.errorMessage)
		}
		
		private function onJoin(evt:SFSEvent):void
		{
			dTrace("Joined in Room: " + evt.params.room.name)
			dTrace("Avatar Image: " + sfs.mySelf.getVariable("avatar").getStringValue())
		}
		
		private function onJoinError(evt:SFSEvent):void
		{
			dTrace("Room Join error: " + evt.params.errorMessage)
		}

		private function onConfigLoadSuccess(evt:SFSEvent):void
		{
			dTrace("Config load success!")
		}
		
		private function onConfigLoadFailure(evt:SFSEvent):void
		{
			dTrace("Config load failure!!!")
		}

		private function dTrace(msg:String):void
		{
			ta_debug.text += "--> " + msg + "\n";
		}
		
	}
}
